Unit DOS;
Interface

uses
  Windows,SysUtils,Forms;

var
  StartUpInfo : TStartupInfo;					{ Process start up information record }
	ProcessInfo	: TProcessInformation;	{ New process information record }
  {Why do these have to be here instead of the procedure? I don't know, but it doesn't do anything if they're in the proc.}

Function DosCmd (Cmd, SUDir: String; Wait: Boolean; var ExitCode: longword): LongBool; {First used in "Xmas2000" Dec 2000}

Implementation

Function DosCmd (Cmd, SUDir: String; Wait: Boolean; var ExitCode: longword): LongBool; {First used in "Xmas2000" Dec 2000}
// Runs a DOS command.
// If SUDir doesnt specify absolute path, it's relative to the application directory.
// 8-12-2003: Added ExitCode return parameter -- returns exit code of console application
// 10-29-2009 If run asyncrhonously (Wait = 0), instead of returning ExitCode=0, set it to the Process ID.
var
  i: integer;
  p: pointer;
begin
  ExitCode := 0;
  if length(SUDir)>0 then
  begin
    if LastDelimiter('\',SUDir) < length(SUDir) then
      SUDir := SUDir + '\'
    ;
    if (copy(SUDir,1,1)='\') or (copy(SUDir,2,1) = ':') then
    else begin
      i := LastDelimiter('\:',Application.ExeName);
      SUDir:=copy(Application.ExeName, 1, i) + SUDir;
    end;
    if (copy(Cmd,1,1)='\') or (copy(Cmd,2,1) = ':') then
    else begin
      Cmd := SUDir + Cmd
    end;
    p := pchar(SUDir);
  end else
  begin
    p := nil;
  end;
  Result := CreateProcess	( nil,							{ Not used - no parameters passed as yet }
									PChar( Cmd ),			{ Command Line - used to allow 16 bit execution & parameters }
									nil,							{ No Process security attributes }
									nil,							{ No Thread security attributes }
									false,						{ No handle inheritance }
									CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,	{ Creation flags }
									nil,							{ No new environment block }
									p,                { Pointer to the current directory }
									StartUpInfo,			{ Pointer to the StartUpInfo block }
									ProcessInfo				{ Pointer to the ProcessInformation block }
  );
  If ProcessInfo.hProcess > 0 then
  begin
    If Wait then
    begin
      repeat
        Application.ProcessMessages;
        sleep(100);
      until WaitForSingleObject(ProcessInfo.hProcess,0) = 0;
      GetExitCodeProcess(ProcessInfo.hProcess, ExitCode);
    end else
    begin
      ExitCode := ProcessInfo.dwProcessId;
    end;
  end;
end;
end.

